;   program dialog interface for polar array

;   1) Unlike the standard way , objects can be selected by window , crossing
;      window polygon , crossing polygon , etc.
;   2) Entries once made can be changed at will 
;      before the command is executed.
;   3) Last used valued are displayed as defaults.   



(defun c:DDPA (/ I_CARD CHEK VALIDATE RESTORE 
	       WHAT_NOW SPA P BM CE)

(defun VALIDATE (/ MARK TILE_KEY)
(cond
(( = PA_ANG nil) (setq MARK T TILE_KEY "ang_fill"))
(( = PA_ITEMS nil) (setq MARK T TILE_KEY "no_items"))
(( /= (numberp PA_ITEMS) T) (setq MARK T))
( T (setq MARK nil) (RESTORE))
)
(if (= MARK T)
(progn
(set_tile "error" "Input Error - Entry Invalid ")
(mode_tile TILE_KEY 2)
))
)
(defun RESTORE () (set_tile "error" ""))

(setq CE (getvar "cmdecho"))
(setq BM (getvar "blipmode"))

(setvar "cmdecho" 0)
(setvar "blipmode" 0)

(setq SPA (ssget))
(setq P (getpoint"Center point of array:"))

(setq I_CARD (load_dialog "ddpa.dcl"))
(if (not  (new_dialog "ddpa" I_CARD )) (exit))

(if (not PA_ITEMS) (setq PA_ITEMS 2))
(setq PA_ANG 360)
(set_tile "no_items" (rtos PA_ITEMS 2 0))
(set_tile "ang_fill" (rtos PA_ANG 2 2))

(action_tile "no_items"
"(setq PA_ITEMS (distof $value 4)) (VALIDATE)"
)
(action_tile "ang_fill"
"(setq PA_ANG (distof $value 4)) (VALIDATE)"
)
(action_tile "togle" "(setq CHEK (atoi $value))")
(action_tile "accept" "(done_dialog 4)")
(action_tile "cancel" "(done_dialog 0)")

(setq WHAT_NOW (start_dialog))
(unload_dialog I_CARD)
(if (= WHAT_NOW 4)
(progn 
(setq PA_ITEMS (fix PA_ITEMS))

(if CHEK
(command "array" SPA "" "polar" P PA_ITEMS PA_ANG "yes")
(command "array" SPA "" "polar" P PA_ITEMS PA_ANG "no")
)

)

)
(setvar "cmdecho" CE)
(setvar "bipmode" BM)
(princ)

)

; ***  more programs in ddra.lsp , programs.lsp  ****